﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using System.Drawing;

public partial class Default4 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void RadGrid1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = Data;
    }
    private DataTable Data
    {
        get
        {
            if (Session["Data"] == null)
            {
                DataTable table = new DataTable();
                table.Columns.Add("ID");
                table.Columns.Add("Item");
                for (int i = 0; i < 10; i++)
                {
                    table.Rows.Add(i, "Item" + i.ToString());
                }
                Session["Data"] = table;
            }
            return (DataTable)Session["Data"];
        }
        set
        {
            Session["Data"] = value;
        }
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        Label1.Text = DateTime.Now.ToString();
    }
    protected void RadGrid1_ItemEvent(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (((e.EventInfo) is GridInitializePagerItem))
        {
            GridInitializePagerItem info = (GridInitializePagerItem)e.EventInfo;
            e.Canceled = true;
            GridPagerItem pagerItem = (GridPagerItem)e.Item;
            pagerItem.PagerContentCell.Controls.Add(new MyPager(info.PagingManager, e.Item.OwnerTableView));
        }
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        div1.Visible = !div1.Visible;
    }
}
public class MyPager : Control
{
    private GridPagingManager paging;
    private GridTableView tableView;
     TextBox myTextBox;
     TextBox myTextBoxN;
    RangeValidator myRangeValidator;

    public MyPager(GridPagingManager paging, GridTableView tableView)
    {
        this.paging = paging;
        this.tableView = tableView;
        this.EnsureChildControls();
    }

    protected override void CreateChildControls()
    {

        LinkButton btnL = new LinkButton();
        LinkButton btnR = new LinkButton();
        btnL.ID = "btnL";
        btnL.Text = "<";
        btnR.ID = "btnR";
        btnR.Text = ">";
        btnR.ForeColor = Color.Blue;
        btnL.ForeColor = Color.Blue;
        this.Controls.Add(btnL);
        this.Controls.Add(new LiteralControl("&nbsp;"));
        this.Controls.Add(btnR);

        this.Controls.Add(new LiteralControl("&nbsp;&nbsp;"));
        btnL.Click += this.BtnL_Click;
        btnR.Click += this.BtnR_Click;


        this.Controls.Add(new LiteralControl("Page: "));

        myTextBox = new TextBox();
        myTextBox.ID = "textbox";
        myTextBox.Columns = 3;

        this.Controls.Add(myTextBox);

        this.Controls.Add(new LiteralControl(" (of " + this.paging.PageCount + ") "));

        LinkButton btn = new LinkButton();
        btn.ID = "btn1";
        btn.Text = "Change page";

        btn.ForeColor = Color.Blue;

        myTextBoxN = new TextBox();
        myTextBoxN.ID = "textboxN";
        myTextBoxN.Columns = 3;


        //Me.Controls.Add(New LiteralControl(" (of " & Me.paging.PageCount & ") "))


        LinkButton ShowMoreButton = new LinkButton();
        ShowMoreButton.ID = "ShowMoreButton";
        ShowMoreButton.Text = "Show Items";
        ShowMoreButton.ForeColor = Color.Blue;
        ShowMoreButton.Click += this.ShowMoreButton_Click;

        this.Controls.Add(new LiteralControl("&nbsp;"));
        this.Controls.Add(btn);
        this.Controls.Add(new LiteralControl("&nbsp;&nbsp;"));
        this.Controls.Add(new LiteralControl("Number of records per page: "));
        this.Controls.Add(new LiteralControl("&nbsp;"));
        this.Controls.Add(myTextBoxN);
        this.Controls.Add(new LiteralControl("&nbsp;"));
        this.Controls.Add(ShowMoreButton);
        this.Controls.Add(new LiteralControl("&nbsp;&nbsp;"));
        this.Controls.Add(new LiteralControl("Total Records:" + this.tableView.PagingManager.DataSourceCount.ToString() + ""));


        btn.Click += this.BtnClick;

        myRangeValidator = new RangeValidator();
        myRangeValidator.ErrorMessage = " Page index should be in the range of 1 to " + this.paging.PageCount;

        this.Controls.Add(myRangeValidator);
    }

    protected override void OnPreRender(EventArgs e)
    {
        myTextBox.Text = (paging.CurrentPageIndex + 1).ToString();
        myTextBoxN.Text = this.tableView.PageSize.ToString();

        myRangeValidator.Type = ValidationDataType.Integer;
        myRangeValidator.MinimumValue = 1.ToString();
        myRangeValidator.MaximumValue = this.paging.PageCount.ToString();

        myRangeValidator.ControlToValidate = myTextBox.ID;

        base.OnPreRender(e);
    }

    protected void BtnClick(object sender, EventArgs e)
    {
        if (!(this.myTextBox.Text.Trim() == ""))
        {
            this.tableView.CurrentPageIndex = int.Parse(this.myTextBox.Text) - 1;
            this.tableView.Rebind();
        }
    }
    protected void BtnL_Click(object sender, EventArgs e)
    {
        if (this.tableView.CurrentPageIndex > 0)
        {
            this.tableView.CurrentPageIndex = this.tableView.CurrentPageIndex - 1;
            this.myTextBox.Text = (this.tableView.CurrentPageIndex + 1).ToString();
            //if Me.tableView.CurrentPageIndex=0 then me.BtnL_Click.
            this.tableView.Rebind();
        }
    }

    protected void BtnR_Click(object sender, EventArgs e)
    {
        if (this.tableView.CurrentPageIndex < this.tableView.PageCount - 1)
        {
            this.tableView.CurrentPageIndex = this.tableView.CurrentPageIndex + 1;
            this.myTextBox.Text = (this.tableView.CurrentPageIndex + 1).ToString();
            this.tableView.Rebind();
        }
    }

    private void ShowMoreButton_Click(object sender, EventArgs e)
    {
        //Me.tableView.PageSize += 5
        if (!(this.myTextBoxN.Text.Trim() == ""))
        {
            this.tableView.PageSize = int.Parse(this.myTextBoxN.Text);
            this.tableView.Rebind();
        }
    }
}

