﻿Imports System.Drawing
Imports Telerik.Web.UI
Imports System.Data

Partial Class DefaultVB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)

    End Sub
    Protected Sub RadGrid1_NeedDataSource(ByVal source As Object, ByVal e As Telerik.Web.UI.GridNeedDataSourceEventArgs)
        RadGrid1.DataSource = Data
    End Sub
    Private Property Data() As DataTable
        Get
            If Session("Data") = Nothing Then
                Dim table As New DataTable()
                table.Columns.Add("ID")
                table.Columns.Add("Item")
                Dim i As Integer = 0
                While i < 10
                    table.Rows.Add(i, "Item" + i.ToString())
                    System.Math.Max(System.Threading.Interlocked.Increment(i), i - 1)
                End While
                Session("Data") = table
            End If
            Return DirectCast(Session("Data"), DataTable)
        End Get
        Set(ByVal value As DataTable)
            Session("Data") = value
        End Set
    End Property
    Protected Sub Button2_Click(ByVal sender As Object, ByVal e As EventArgs)
        Label1.Text = DateTime.Now.ToString()
    End Sub
    Protected Sub RadGrid1_ItemEvent(ByVal sender As Object, ByVal e As Telerik.Web.UI.GridItemEventArgs)
        If (TypeOf (e.EventInfo) Is GridInitializePagerItem) Then
            Dim info As GridInitializePagerItem = DirectCast(e.EventInfo, GridInitializePagerItem)
            e.Canceled = True
            Dim pagerItem As GridPagerItem = DirectCast(e.Item, GridPagerItem)
            pagerItem.PagerContentCell.Controls.Add(New MyPager(info.PagingManager, e.Item.OwnerTableView))
        End If
    End Sub
    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs)
        div1.Visible = Not div1.Visible
    End Sub
End Class
Public Class MyPager
    Inherits Control
    Private paging As GridPagingManager
    Private tableView As GridTableView
    Private myTextBox As TextBox
    Private myTextBoxN As TextBox
    Private myRangeValidator As RangeValidator

    Public Sub New(ByVal paging As GridPagingManager, ByVal tableView As GridTableView)
        Me.paging = paging
        Me.tableView = tableView
        Me.EnsureChildControls()
    End Sub

    Protected Overloads Overrides Sub CreateChildControls()

        Dim btnL As New LinkButton()
        Dim btnR As New LinkButton()
        btnL.ID = "btnL"
        btnL.Text = "<"
        btnR.ID = "btnR"
        btnR.Text = ">"
        btnR.ForeColor = Color.Blue
        btnL.ForeColor = Color.Blue
        Me.Controls.Add(btnL)
        Me.Controls.Add(New LiteralControl("&nbsp;"))
        Me.Controls.Add(btnR)

        Me.Controls.Add(New LiteralControl("&nbsp;&nbsp;"))
        AddHandler btnL.Click, AddressOf Me.BtnL_Click
        AddHandler btnR.Click, AddressOf Me.BtnR_Click


        Me.Controls.Add(New LiteralControl("Page: "))

        myTextBox = New TextBox()
        myTextBox.ID = "textbox"
        myTextBox.Columns = 3

        Me.Controls.Add(myTextBox)

        Me.Controls.Add(New LiteralControl(" (of " + Me.paging.PageCount.ToString() + ") "))

        Dim btn As New LinkButton()
        btn.ID = "btn1"
        btn.Text = "Change page"

        btn.ForeColor = Color.Blue

        myTextBoxN = New TextBox()
        myTextBoxN.ID = "textboxN"
        myTextBoxN.Columns = 3


        'Me.Controls.Add(New LiteralControl(" (of " & Me.paging.PageCount & ") "))


        Dim ShowMoreButton As New LinkButton()
        ShowMoreButton.ID = "ShowMoreButton"
        ShowMoreButton.Text = "Show Items"
        ShowMoreButton.ForeColor = Color.Blue
        AddHandler ShowMoreButton.Click, AddressOf Me.ShowMoreButton_Click

        Me.Controls.Add(New LiteralControl("&nbsp;"))
        Me.Controls.Add(btn)
        Me.Controls.Add(New LiteralControl("&nbsp;&nbsp;"))
        Me.Controls.Add(New LiteralControl("Number of records per page: "))
        Me.Controls.Add(New LiteralControl("&nbsp;"))
        Me.Controls.Add(myTextBoxN)
        Me.Controls.Add(New LiteralControl("&nbsp;"))
        Me.Controls.Add(ShowMoreButton)
        Me.Controls.Add(New LiteralControl("&nbsp;&nbsp;"))
        Me.Controls.Add(New LiteralControl("Total Records:" + Me.tableView.PagingManager.DataSourceCount.ToString() + ""))


        AddHandler btn.Click, AddressOf Me.BtnClick

        myRangeValidator = New RangeValidator()
        myRangeValidator.ErrorMessage = " Page index should be in the range of 1 to " + Me.paging.PageCount.ToString()

        Me.Controls.Add(myRangeValidator)
    End Sub

    Protected Overloads Overrides Sub OnPreRender(ByVal e As EventArgs)
        myTextBox.Text = (paging.CurrentPageIndex + 1).ToString()
        myTextBoxN.Text = Me.tableView.PageSize.ToString()

        myRangeValidator.Type = ValidationDataType.[Integer]
        myRangeValidator.MinimumValue = 1.ToString()
        myRangeValidator.MaximumValue = Me.paging.PageCount.ToString()

        myRangeValidator.ControlToValidate = myTextBox.ID

        MyBase.OnPreRender(e)
    End Sub

    Protected Sub BtnClick(ByVal sender As Object, ByVal e As EventArgs)
        If Not (Me.myTextBox.Text.Trim() = "") Then
            Me.tableView.CurrentPageIndex = Integer.Parse(Me.myTextBox.Text) - 1
            Me.tableView.Rebind()
        End If
    End Sub
    Protected Sub BtnL_Click(ByVal sender As Object, ByVal e As EventArgs)
        If Me.tableView.CurrentPageIndex > 0 Then
            Me.tableView.CurrentPageIndex = Me.tableView.CurrentPageIndex - 1
            Me.myTextBox.Text = (Me.tableView.CurrentPageIndex + 1).ToString()
            'if Me.tableView.CurrentPageIndex=0 then me.BtnL_Click.
            Me.tableView.Rebind()
        End If
    End Sub

    Protected Sub BtnR_Click(ByVal sender As Object, ByVal e As EventArgs)
        If Me.tableView.CurrentPageIndex < Me.tableView.PageCount - 1 Then
            Me.tableView.CurrentPageIndex = Me.tableView.CurrentPageIndex + 1
            Me.myTextBox.Text = (Me.tableView.CurrentPageIndex + 1).ToString()
            Me.tableView.Rebind()
        End If
    End Sub

    Private Sub ShowMoreButton_Click(ByVal sender As Object, ByVal e As EventArgs)
        'Me.tableView.PageSize += 5
        If Not (Me.myTextBoxN.Text.Trim() = "") Then
            Me.tableView.PageSize = Integer.Parse(Me.myTextBoxN.Text)
            Me.tableView.Rebind()
        End If
    End Sub
End Class